/******************************************************************************
    Program ictdatedit, builds and edit database from analyze test files,
    for ic-tester program:
    - callbacks.c - source file for callbacks functions from buttons, etc.

    Copyright (C) 2001 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/

#include <gtk/gtk.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <errno.h>
#include <string.h>

#include "support.h"
#include "timeset.h"
#include "ictdat.h"
#include "dialog.h"
#include "initall.h"
#include "refresh.h"
#include "save.h"
#include "load.h"
#include "testfile.h"

void on_tfncombo_selected(GtkEditable *editable, gpointer user_data)
{
if (ictdata.changed){/* current entry changed, ask to save */
 qdialog(g_strconcat("\nChanges are made on current entry.\nDo you wish to\
 discard all changes and load new data?\n", NULL));
}else rezultat=1;/* end if entry changed */
if (rezultat==1){/* reload current entry */
 if(strcmp(ictdata.entry,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(tfncombo)->entry)))!=0){/* ok there's new entry selected, do update */
  if(check_existance(g_strconcat(adbi.databaseloc,"/",gtk_entry_get_text(\
	GTK_ENTRY(GTK_COMBO(tfncombo)->entry)),".info",NULL))==-1){/* no file */
   quick_message(g_strconcat("\nNo temp file for the name of this entry.\n\
 Error in program, somewhere, hm....\n",NULL));
  }else{ LoadEntry(g_strconcat(adbi.databaseloc,"/",gtk_entry_get_text(\
	GTK_ENTRY(GTK_COMBO(tfncombo)->entry)),NULL));/* temp found, open it */
   ictdata.changed=FALSE;}/* end else if exists */
 }/* end if new entry */
}else/* do not erase current entry */
 gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(tfncombo)->entry),ictdata.entry);
dialog_active=FALSE;update_entries();/* update status */
}/* end on_tfncombo_changed() */

void on_lfncombo_selected(GtkEditable *editable, gpointer user_data)
{
if(strcmp(ictdata.entry,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(lfncombo)->entry)))!=0){/* ok there's new entry selected */
 ictdata.changed=TRUE;gtk_widget_set_sensitive(delbutton, FALSE);
 gtk_widget_set_sensitive(savebutton,TRUE);}/* end if new entry */
dialog_active=FALSE;update_entries();/* clear hold */
}/* end on_lfncombo_changed() */

void on_tfncombo_selecting (GtkEditable *editable, gpointer user_data) {
strcpy(ictdata.entry,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(tfncombo)->entry)));
dialog_active=TRUE;}/* end on_tfncombo_selecting() */

void on_lfncombo_selecting (GtkEditable *editable, gpointer user_data) {
strcpy(ictdata.entry,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(lfncombo)->entry)));
dialog_active=TRUE;}/* end on_lfncombo_selecting() */

void on_combotxt_changed (GtkEditable *editable, gpointer user_data)
{ 
if(!dialog_active){/* make update only if there are no selecting in progress */
 if(ictdata.tfname){/* ok there's a new entry change all */
  ictdata.changed=TRUE;gtk_widget_set_sensitive(delbutton, FALSE);
  gtk_widget_set_sensitive(savebutton, TRUE);
 }else ictdata.changed=FALSE; /* no changes only display status */
}/* end if selecting in progress */
}/* end on_combotxt_changed() */

void on_comboltxt_changed (GtkEditable *editable, gpointer user_data)
{ 
if(!dialog_active){/* make update only if there are no selecting in progress */
 if(ictdata.tfname){/* ok there's a new entry change all */
  ictdata.changed=TRUE;gtk_widget_set_sensitive(delbutton, FALSE);
  gtk_widget_set_sensitive(savebutton, TRUE);
 }else ictdata.changed=FALSE; /* no changes only display status */
}/* end if selecting in progress */
}/* end on_comboltxt_changed() */

void on_closebutton_clicked (GtkButton *button, gpointer user_data)
{
if(!adbi.changed){/* no changes, or changes saved */
 deltree(adbi.databaseloc);/* clean temp database */
 rename(g_strconcat(adbi.databaseloc,"t",NULL),adbi.databaseloc);/* rename */
}/* end if changed */
gtk_main_quit (); }/* on_closebutton_clicked() */

void on_inportbutton_clicked (GtkButton *button, gpointer user_data)
{
if(ictdata.changed){/* there was changes, ask to save */
 qdialog(g_strconcat("\nChanges are made on current entry.\nDo you wish to\
 erase all changes and import new data?\n", NULL));
}else rezultat=1;/* end if ictdata.changed */
if(rezultat==1){/* reset all */
 fileloc[0]=0;create_savelog("Select analize test file",
		g_strconcat(PACKAGE_DATA_DIR,"/default.adf",NULL),"*.adf");
 if(fileloc[0]!=0) ictdata.changed|=addtestfile(fileloc);
 update_entries();/* update status */
}/* end if not ictdata.changed */
}/* end on_inportbutton_clicked() */

void on_exportbutton_clicked (GtkButton *button, gpointer user_data)
{
fileloc[0]=0;create_savelog("Location of analize test file where to export",
	g_strconcat(PACKAGE_DATA_DIR,"/",gtk_entry_get_text(GTK_ENTRY(\
	GTK_COMBO(tfncombo)->entry)),".adf",NULL),"*.adf");
if(fileloc[0]!=0){/* ok location selected */
 if(check_existance(fileloc)!=-1)/* something exists, ask to overwrite */
  qdialog(g_strconcat("\nFile \"",fileloc,"\" exists.\nDo you wish to overwrite\
 it?",NULL));/* ask */
 else rezultat=1;/* no file */
 if(rezultat==1) exptestfile(fileloc);/* write file */
 update_entries();/* update status */
}/* end if location selected */
}/* end on_inportbutton_clicked() */

void on_savebutton_clicked (GtkButton *button, gpointer user_data)
{ 
gtk_widget_set_sensitive(tfncombo, FALSE);ictdata.entry[0]=0;
strcpy(ictdata.entry,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(tfncombo)->entry)));
if(ictdata.entry[0]==0)/* no entry, erased ? */
 quick_message(g_strconcat("\nWoha, missing name!\nType the name of this entry\
 and hit save button again.\n",NULL));
else{/* all ok continue... */
 if(ictdata.islnk){/* it's link, check if they have location */
  ictdata.entry[0]=0;strcpy(ictdata.entry,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(lfncombo)->entry)));
 }else/* it's test, chack if they have test data */
  if(gtk_text_get_length(GTK_TEXT(testtext))>0) ictdata.entry[0]=32;
  else ictdata.entry[0]=0;
 if(ictdata.entry[0]==0)/* no something */
  if(ictdata.islnk) quick_message(g_strconcat("\nMissing link location!\nType\
 or select location where pointing this link.\n",NULL));
  else quick_message(g_strconcat("\nNo test data!\nWrite some test data and hit\
 save button again.\n",NULL));
 else{/* all ok */
  ictdata.entry[0]=0;strcpy(ictdata.entry,gtk_entry_get_text(GTK_ENTRY(moddate)));
  SetNewTime();/* new date, create it */
  if(!SaveEntry(g_strconcat(adbi.databaseloc,"/",gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(tfncombo)->entry)),NULL))){/* changes saved */
  addtoiclist();adbi.changed=TRUE;ictdata.changed=FALSE;update_entries();}
 }/* end else if link or test entry */
}/* end else if entry name */
gtk_widget_set_sensitive(tfncombo, TRUE);/* enable select dialog */
}/* end on_savebutton_clicked() */

void on_savedatabase_clicked (GtkButton *button, gpointer user_data)
{
gchar *ch;
gint errors=0;

gtk_label_get(GTK_LABEL (GTK_BUTTON(button)->child), &ch);
if(strcmp(ch,"New")==0){/* ok new button is clicked, create database */
 create_savelog("Type database file (*.tdf)",\
	g_strconcat(PACKAGE_DATA_DIR,"/new.tdf",NULL),"*.tfd");
 if(fileloc[0]!=0){/* update status if there's selected location */
  if(adbi.changed){/* there's changes */
   qdialog(g_strconcat("\nThere are changes in current database.\
\nDo you wish to save changes?\n",NULL));/* ask to save */
   if(rezultat==1){ SaveDBase(adbi.databaseloc);adbi.changed=FALSE;}/* saved */
  }/* if changes in database */
  if(adbi.databaseloc[0]!=0){/* there's database, remove it */
   deltree(adbi.databaseloc);/* clean temp database */
   rename(g_strconcat(adbi.databaseloc,"t",NULL),adbi.databaseloc);/* rename */
  }/* end if database exists */
  strcpy(adbi.databaseloc,fileloc);/* copy database location */
  switch (check_existance (adbi.databaseloc)){/* check type */
   case 0: /* ok, directory exists */
	qdialog(g_strconcat("\nDatabase with that name alredy exists.\nDelete\
 database \"",adbi.databaseloc,"\"?\n", NULL));
	if(rezultat==1){/* ok delete it */
         deltree(adbi.databaseloc);errors=0;/* remove if any exists */
         errors=mkdir(adbi.databaseloc,S_IRWXU);/* try to create */
	}else{ errors=-1; errno=13; } break;/* premission denied */
   case 1: /* ok, file exists */
	qdialog(g_strconcat("\nDelete alredy created database \"",
	adbi.databaseloc,"\"?\n",NULL));
	if(rezultat==1){/* ok delete it */
         remove(adbi.databaseloc);errors=0;/* remove it */
         errors=mkdir(adbi.databaseloc,S_IRWXU);/* try to create */
	}else{ errors=-1; errno=13; } break;/* premission denied */
   default:/* no file or something else */
        remove(adbi.databaseloc);unlink(adbi.databaseloc);/* remove it */
	errors=mkdir(adbi.databaseloc,S_IRWXU);break;/* try to create */
  }/* end switch */
  if(errors==-1){/* error in creating directory */
   quick_message(g_strconcat("\nCann't create new database \"",
	adbi.databaseloc,"\" !!!\nError:",g_strerror(errno),NULL)); 
   init_all();/* cancel everything */
  }else{/* all ok enable input */
   adbi.changed=FALSE;fileloc[0]=0;rezultat=-1;dialog_active=FALSE;
   ictdata.islnk=TRUE;ictdata.changed=FALSE;ictdata.entry[0]=0;
   adbi.tfnlist=NULL;adbi.tfnlist=g_list_append(adbi.tfnlist,"");
   gtk_combo_set_popdown_strings(GTK_COMBO(tfncombo),adbi.tfnlist);
   adbi.tfnlist=NULL;adbi.lfnlist=NULL;
   gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (tfncombo)->entry),"");
   adbi.lfnlist=g_list_append(adbi.lfnlist,"");
   gtk_combo_set_popdown_strings(GTK_COMBO(lfncombo),adbi.lfnlist);
   adbi.lfnlist=NULL;ictdata.tfname=FALSE;/* ok there isn't a new entry */
   gtk_entry_set_text(GTK_ENTRY (description), "");
   gtk_entry_set_text(GTK_ENTRY (truename), "");
   if(gtk_text_get_length(GTK_TEXT (testediclist))>0){/* clear tested ic list */
    gtk_text_set_point(GTK_TEXT (testediclist),0);
    gtk_text_forward_delete(GTK_TEXT (testediclist), gtk_text_get_length(GTK_TEXT (testediclist)));}/* end if length */
   if(gtk_text_get_length(GTK_TEXT (authorslist))>0){/* clear author list */
    gtk_text_set_point(GTK_TEXT (authorslist),0);
    gtk_text_forward_delete(GTK_TEXT (authorslist), gtk_text_get_length(GTK_TEXT (authorslist)));}/* end if length */
   gtk_entry_set_text(GTK_ENTRY (moddate), "");
   gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (lfncombo)->entry), "");
   if(gtk_text_get_length(GTK_TEXT(testtext))>0){/* clear data */
    gtk_text_set_point(GTK_TEXT (testtext),0);gtk_text_forward_delete(
	GTK_TEXT(testtext),gtk_text_get_length(GTK_TEXT(testtext)));}/*end if*/
   ictdata.changed=FALSE;update_entries();/* all ok enable all inputs */
  }/* end else if mkdir succesfull */
 }/* end if fileloc entry exists */
}else{/* save button is clicked, save database */
 if(SaveDBase(adbi.databaseloc)) adbi.changed=FALSE;/* saved ok */
 update_entries();/* do refresh */
}/* end else if New button */
}/* end on_savedatabase_clicked() */

void on_loadsatabase_clicked (GtkButton *button, gpointer user_data)
{
gint errors=0;

fileloc[0]=0;create_savelog("Select database to load (*.tdf)",
	g_strconcat(PACKAGE_DATA_DIR,"/new.tdf",NULL),"*.tfd");
if((fileloc[0]!=0)&&(strcmp(fileloc,adbi.databaseloc)!=0)){/* all ok continue */
 if(adbi.changed){/* there's changes */
  qdialog(g_strconcat("\nThere are changes in current database.\
\nDo you wish to save changes?\n",NULL));/* ask to save */
  if(rezultat==1) on_savedatabase_clicked (NULL, NULL);
 }/* if changes in database */
 if(adbi.databaseloc[0]!=0){/* there's database, remove it */
  deltree(adbi.databaseloc);/* clean temp database */
  rename(g_strconcat(adbi.databaseloc,"t",NULL),adbi.databaseloc);/* rename */
 }/* end if database exists */
 strcpy(adbi.databaseloc,fileloc);/* copy location */
 switch (check_existance (adbi.databaseloc)){/* check type */
  case -1: /* not found */
         quick_message(g_strconcat("\nAccess error to \"",adbi.databaseloc,
	"\":\n",g_strerror(errno),NULL));
	 init_all();break;/* cancel everything */
  case 0: /* ok, directory exists */
	 adbi.databaseloc[strlen(adbi.databaseloc)-1]=0;/* remove '/' */
	 LoadFromDir(adbi.databaseloc);break;/* get data from directory */
  case 1: /* ok, file exists */
         rename(adbi.databaseloc,g_strconcat(adbi.databaseloc,"t",NULL));
         errors=mkdir(adbi.databaseloc,S_IRWXU);/* try to create */
         if(errors==-1){/* error in creating directory */
          quick_message(g_strconcat("\nCann't load new database \"",
	adbi.databaseloc,"\" !!!\nError:",g_strerror(errno),NULL)); 
         init_all();/* cancel everything */
	 }else if(LoadFromDatabase(adbi.databaseloc)){ /* load fail */
	  deltree(adbi.databaseloc);/* clean temp database */
	  rename(g_strconcat(adbi.databaseloc,"t",NULL),adbi.databaseloc);
	  init_all();}else ictdata.changed=FALSE;/* end if load fail */
	 break;/* end if file */
  default:/* no file or something else */
         quick_message(g_strconcat("\nUnknow type of file:\n\"",
	adbi.databaseloc,"\"\n",NULL));init_all();/* cancel everything */
	 break;/* error */
 }/* end switch */
 update_entries();/* all ok enable all inputs */
}/* end if fileloc don't match */
}/* end on_loadsatabase_clicked() */

void on_delbutton_clicked (GtkButton *button, gpointer user_data)
{
GList *tmp=NULL;
gchar entryn[128];

gtk_widget_set_sensitive(tfncombo, FALSE);/* disable entry */
strcpy(entryn,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(tfncombo)->entry)));
qdialog(g_strconcat("\nDo you wish to erase \"",entryn,
	"\" entry, with all contents?\n",NULL));
if(rezultat==1){/* ok delete entry and all with it */
 if(g_list_length(adbi.tfnlist)<=1){ adbi.tfnlist=NULL;/* if last element */
  tmp=g_list_append(tmp,"");gtk_combo_set_popdown_strings(GTK_COMBO(tfncombo),
	tmp);tmp=NULL;/* clear entry */
 }else{/* there's more elements */
  tmp=g_list_find_custom(adbi.tfnlist,entryn,(GCompareFunc) strcmp);
  if(tmp!=NULL) adbi.tfnlist=g_list_remove(adbi.tfnlist,tmp->data);tmp=NULL;
  gtk_combo_set_popdown_strings(GTK_COMBO(tfncombo),adbi.tfnlist);
 }/* end else if last element */
 if(g_list_length(adbi.lfnlist)<=1){ adbi.lfnlist=NULL;/* if last element */
  tmp=g_list_append(tmp,"");gtk_combo_set_popdown_strings(GTK_COMBO(lfncombo),
	tmp);tmp=NULL;/* clear entry */
 }else{/* there's more elements */
  tmp=g_list_find_custom(adbi.lfnlist,entryn,(GCompareFunc) strcmp);
  if(tmp!=NULL) adbi.lfnlist=g_list_remove(adbi.lfnlist,tmp->data);tmp=NULL;
  gtk_combo_set_popdown_strings(GTK_COMBO(lfncombo),adbi.lfnlist);
 }/* end else if last element */
 strcpy(ictdata.entry,g_strconcat(adbi.databaseloc,"/",entryn,NULL));
 remove(g_strconcat(ictdata.entry,".info",NULL));/* try to delete file */
 unlink(g_strconcat(ictdata.entry,".info",NULL));/* if it's link delete it */
 remove(g_strconcat(ictdata.entry,".tmp",NULL));/* try to delete file */
 unlink(g_strconcat(ictdata.entry,".tmp",NULL));/* if it's link delete it */
 gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (tfncombo)->entry),"");
 ictdata.tfname=FALSE;/* there's not new entry */
 ictdata.islnk=TRUE;gtk_entry_set_text(GTK_ENTRY (truename), "");
 gtk_entry_set_text(GTK_ENTRY (description), "");
 if(gtk_text_get_length(GTK_TEXT (testediclist))>0){/* clear tested ic list */
  gtk_text_set_point(GTK_TEXT (testediclist),0);
  gtk_text_forward_delete(GTK_TEXT (testediclist), gtk_text_get_length(GTK_TEXT (testediclist)));}/* end if length */
 if(gtk_text_get_length(GTK_TEXT (authorslist))>0){/* clear author list */
  gtk_text_set_point(GTK_TEXT (authorslist),0);
  gtk_text_forward_delete(GTK_TEXT (authorslist), gtk_text_get_length(GTK_TEXT (authorslist)));}/* end if length */
 SetNewTime();if(gtk_text_get_length(GTK_TEXT(testtext))>0){
  gtk_text_set_point(GTK_TEXT (testtext),0);/* clear test data */
  gtk_text_forward_delete(GTK_TEXT(testtext),gtk_text_get_length(
	GTK_TEXT(testtext)));}/* end if length */
 gtk_label_set_text (GTK_LABEL(typeIsize), "In database entry size: 0 Bytes");
 ictdata.changed=FALSE;adbi.changed=TRUE;update_entries();/* update status */
}else /* end if not ictdata.changed */
 gtk_widget_set_sensitive(tfncombo, TRUE);/* enable entry */
}/* on_delbutton_clicked() */

void on_newbutton_clicked (GtkButton *button, gpointer user_data)
{
if(ictdata.changed){/* there was changes, ask to save */
 qdialog(g_strconcat("\nChanges are made on current entry.\nDo you wish to\
 erase all changes and make new entry?\n", NULL));
}else rezultat=1;/* end if ictdata.changed */
if(rezultat==1){/* reset all */
 gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (tfncombo)->entry),"New");
 ictdata.tfname=TRUE;/* ok there's a new entry */
 gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (lfncombo)->entry), "New");
 ictdata.islnk=TRUE;gtk_entry_set_text(GTK_ENTRY (truename), "");
 gtk_entry_set_text(GTK_ENTRY (description), "");
 if(gtk_text_get_length(GTK_TEXT (testediclist))>0){/* clear tested ic list */
  gtk_text_set_point(GTK_TEXT (testediclist),0);
  gtk_text_forward_delete(GTK_TEXT (testediclist), gtk_text_get_length(GTK_TEXT (testediclist)));}/* end if length */
 if(gtk_text_get_length(GTK_TEXT (authorslist))>0){/* clear author list */
  gtk_text_set_point(GTK_TEXT (authorslist),0);
  gtk_text_forward_delete(GTK_TEXT (authorslist), gtk_text_get_length(GTK_TEXT (authorslist)));}/* end if length */
 SetNewTime();if(gtk_text_get_length(GTK_TEXT(testtext))>0){
  gtk_text_set_point(GTK_TEXT (testtext),0);/* clear test data */
  gtk_text_forward_delete(GTK_TEXT(testtext),gtk_text_get_length(
	GTK_TEXT(testtext)));}/* end if length */
 gtk_label_set_text (GTK_LABEL(typeIsize), "In database entry size: 0 Bytes");
 ictdata.changed=TRUE;update_entries();/* update status */
}/* end if not ictdata.changed */
}/* on_newbutton_clicked() */

void on_testtext_changed (GtkEditable *editable, gpointer user_data)
{
ictdata.changed=TRUE;
// check syntax when typing
}/* on_testtext_changed() */

void on_entry_check (GtkEditable *editable, gpointer user_data)
{ ictdata.changed=TRUE; }/* on_entry_changed() */

void on_islink_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
gtk_widget_set_sensitive(testtext, FALSE);
if((ictdata.tfname)&&(gtk_toggle_button_get_active(
	GTK_TOGGLE_BUTTON(islink)))){/* ok there's a new entry change all */
 ictdata.islnk=TRUE;ictdata.changed=TRUE;update_entries();}/* update status */
}/* end on_islink_toggled() */

void on_istest_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
gtk_widget_set_sensitive(testtext, TRUE);
if((ictdata.tfname)&&(gtk_toggle_button_get_active(
	GTK_TOGGLE_BUTTON(istest)))){/* ok there's a new entry change all */
 ictdata.islnk=FALSE;ictdata.changed=TRUE;update_entries();}/* update status */
}/* end on_istest_toggled() */
