/******************************************************************************
    Program ictdatedit, builds and edit database from analyze test files,
    for ic-tester program:
    - initall.c - source file for initial functions which (re)sets program

    Copyright (C) 2001 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <string.h>

#include "ictdat.h"
#include "refresh.h"

void init_all(void)
{
adbi.databaseloc[0]=0;adbi.changed=FALSE;adbi.tfnlist=NULL;adbi.lfnlist=NULL;
fileloc[0]=0;rezultat=-1;dialog_active=FALSE;ictdata.islnk=TRUE;
ictdata.entry[0]=0;ictdata.tfname=FALSE;
gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (tfncombo)->entry),"");
gtk_entry_set_text(GTK_ENTRY (description), "");
gtk_entry_set_text(GTK_ENTRY (truename), "");
if(gtk_text_get_length(GTK_TEXT (testediclist))>0){/* clear tested ics list */
 gtk_text_set_point(GTK_TEXT (testediclist),0);
 gtk_text_forward_delete(GTK_TEXT (testediclist), gtk_text_get_length(GTK_TEXT (testediclist)));}/* end if length */
if(gtk_text_get_length(GTK_TEXT (authorslist))>0){/* clear author list */
 gtk_text_set_point(GTK_TEXT (authorslist),0);
 gtk_text_forward_delete(GTK_TEXT (authorslist), gtk_text_get_length(GTK_TEXT (authorslist)));}/* end if length */
 gtk_entry_set_text(GTK_ENTRY (moddate), "");
 gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (lfncombo)->entry), "");
if(gtk_text_get_length(GTK_TEXT(testtext))>0){/* clear data */
 gtk_text_set_point(GTK_TEXT (testtext),0);gtk_text_forward_delete(
	GTK_TEXT(testtext),gtk_text_get_length(GTK_TEXT(testtext)));}/*end if*/
ictdata.changed=FALSE;update_entries();/* disable buttons and clear input box */
}/* end init_all() */

void deltree(const gchar *location)
{/* recursive delete location */
struct dirent *d;
struct stat s;
DIR *D;

if((D=opendir(location))!=NULL){/* directory opened */
 d=readdir(D);/* read first entry (possible ".") */
 while(d!=NULL){/* go thru listing */
  if((strcmp(d->d_name,".")!=0)&&(strcmp(d->d_name,"..")!=0)){/* true names */
   stat (g_strconcat(location,"/",d->d_name,NULL), &s);/* get status */
   if(S_ISDIR (s.st_mode)) deltree(g_strconcat(location,"/",d->d_name,NULL));
   else{ remove(g_strconcat(location,"/",d->d_name,NULL));
    unlink(g_strconcat(location,"/",d->d_name,NULL));}/* delete file or link */
  }/* end if not true name */
  d=readdir(D);/* read next entry */
 }/* end while */
 closedir(D);}/* close directory */
remove(location);
}/* end deltree() */

void addtoiclist(void)
{/* add entry to lists */
gchar lin[128];

strcpy(lin,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(tfncombo)->entry)));
if (g_list_find_custom(adbi.tfnlist, g_strdup(lin),
	(GCompareFunc) strcmp)==NULL)/* ok new entry add it */
 adbi.tfnlist = g_list_insert_sorted (adbi.tfnlist, g_strdup(lin), 
	(GCompareFunc) strcmp);/* insert sorted into list */
gtk_combo_set_popdown_strings (GTK_COMBO (tfncombo), adbi.tfnlist);
gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(tfncombo)->entry),lin);
if(ictdata.islnk)/* link file, add it to link list */
 strcpy(lin,gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(lfncombo)->entry)));
if (g_list_find_custom(adbi.lfnlist, g_strdup(lin),
	(GCompareFunc) strcmp)==NULL)/* ok new entry add it */
adbi.lfnlist = g_list_insert_sorted (adbi.lfnlist, g_strdup(lin),
	(GCompareFunc) strcmp);/* insert sorted into list */
gtk_combo_set_popdown_strings (GTK_COMBO (lfncombo), adbi.lfnlist);
gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(lfncombo)->entry),lin);
}/* end addtoiclist() */
