/******************************************************************************
    Program ictdatedit, builds and edit database from analyze test files,
    for ic-tester program:
    - load.c - source file for functions which loads informtions from file

    Copyright (C) 2001 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <errno.h>
#include <string.h>

#include "ictdat.h"
#include "dialog.h"
#include "refresh.h"
#include "initall.h"
#include "convert.h"

gboolean LoadEntry(const gchar *flocation)
{
FILE *f;
guint i;
gulong fotsize;

if((f=fopen(g_strconcat(flocation,".info",NULL),"rb"))==NULL){/* cann't read */
 quick_message(g_strconcat("\nOho, can not open info file ",flocation,"!\n\
 Error: ",g_strerror(errno),NULL));return(TRUE);/* return error */
}else{/* all ok file open */
 i=fgetc(f);/* get type and size of string */
 if (i&128) ictdata.islnk=TRUE;else ictdata.islnk=FALSE;i&=127;/* It's link */
 fseek(f,(glong) i,SEEK_CUR);ictdata.tfname=TRUE;
 if(ictdata.islnk){/* link entry read location */
  i=fgetc(f);ictdata.entry[0]=0;fgets(ictdata.entry,i+1,f);/* read entry */
  gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(lfncombo)->entry), ictdata.entry);
 }/* end if islink */
 fotsize=(gulong)fgetc(f)*256*256*256;fotsize+=(gulong)fgetc(f)*256*256;
 fotsize+=(gulong)fgetc(f)*256;fotsize+=(gulong)fgetc(f);/* get tmp size */
 fotsize+=ftell(f);fclose(f);/* close info file */
 sprintf(ictdata.entry,"In database entry size: %ld Bytes",fotsize);
 gtk_label_set_text (GTK_LABEL(typeIsize), ictdata.entry);/* write size */
 if((f=fopen(g_strconcat(flocation,".tmp",NULL),"rb"))==NULL){/* cann't read */
  quick_message(g_strconcat("\nOho, can not open temp file ",flocation,"!\n\
 Error: ",g_strerror(errno),NULL));return(TRUE);/* return error */
 }else{/* all ok file open */
  i=fgetc(f);ictdata.entry[0]=0;fgets(ictdata.entry,i+1,f);/* read entry */
  i-=strlen(ictdata.entry);if((guint)i>0) fseek(f,(glong)i,SEEK_CUR);
  gtk_entry_set_text(GTK_ENTRY(truename),ictdata.entry);/* set true name */
  i=fgetc(f);ictdata.entry[0]=0;fgets(ictdata.entry,i+1,f);/* read entry */
  i-=strlen(ictdata.entry);if((guint)i>0) fseek(f,(glong)i,SEEK_CUR);
  gtk_entry_set_text(GTK_ENTRY(description),ictdata.entry);/* set descr */
  fotsize=(gulong)fgetc(f)*256;fotsize+=(gulong)fgetc(f);/* get txt size */
  if(gtk_text_get_length(GTK_TEXT (testediclist))>0){/* clear tested ics list */
   gtk_text_set_point(GTK_TEXT (testediclist),0);
   gtk_text_forward_delete(GTK_TEXT (testediclist), gtk_text_get_length(GTK_TEXT (testediclist)));}/* end if length */
  gtk_text_freeze(GTK_TEXT (testediclist));/* begin update */
  for(i=0;i<(guint)fotsize;i++){
   ictdata.entry[1]=0;ictdata.entry[0]=fgetc(f);gtk_text_insert(GTK_TEXT(\
testediclist),NULL,NULL,NULL,ictdata.entry,1);}/* end for ic list */
  gtk_text_thaw(GTK_TEXT (testediclist));/* end ics list update */
  fotsize=(gulong)fgetc(f)*256;fotsize+=(gulong)fgetc(f);/* get txt size */
  if(gtk_text_get_length(GTK_TEXT (authorslist))>0){/* clear authors list */
   gtk_text_set_point(GTK_TEXT (authorslist),0);
   gtk_text_forward_delete(GTK_TEXT (authorslist), gtk_text_get_length(GTK_TEXT (authorslist)));}/* end if length */
  gtk_text_freeze(GTK_TEXT (authorslist));/* begin update */
  for(i=0;i<(guint)fotsize;i++){
   ictdata.entry[1]=0;ictdata.entry[0]=fgetc(f);gtk_text_insert(GTK_TEXT(\
authorslist),NULL,NULL,NULL,ictdata.entry,1);}/* end for author list */
  gtk_text_thaw(GTK_TEXT (authorslist));/* end authors list update */
  ictdata.entry[0]=0;fgets(ictdata.entry,21,f);/* get date of change */
  i=20-strlen(ictdata.entry);if((guint)i>0) fseek(f,(glong)i,SEEK_CUR);
  gtk_entry_set_text(GTK_ENTRY(moddate),ictdata.entry);/* set date */
  fotsize=(gulong)fgetc(f)*256*256*256;fotsize+=(gulong)fgetc(f)*256*256;
  fotsize+=(gulong)fgetc(f)*256;fotsize+=(gulong)fgetc(f);/* get skip bit */
  if(fotsize>0) fseek(f,fotsize,SEEK_CUR);/* skip new entry */
/* here come entries for picture and other new addons to database */
  if(gtk_text_get_length(GTK_TEXT (testtext))>0){/* clear authors list */
   gtk_text_set_point(GTK_TEXT (testtext),0);
   gtk_text_forward_delete(GTK_TEXT (testtext), gtk_text_get_length(GTK_TEXT(testtext)));}/* end if length */
  gtk_text_freeze(GTK_TEXT (testtext));/* begin update */
  do{/* go to the end of file */
   i=fgetc(f);switch(i) {/* check type of action */
	case -1:break;/* possible end of file? */
	case 4:/* pause entry */
		i=fgetc(f);ictdata.entry[0]=0;fgets(ictdata.entry,i+1,f);
		gtk_text_insert(GTK_TEXT(testtext),NULL,NULL,NULL,g_strconcat(\
 "P: ",ictdata.entry,"\n",NULL),i+4);break;
	case 3:/* question error entry */
		i=fgetc(f);ictdata.entry[0]=0;fgets(ictdata.entry,i+1,f);
		gtk_text_insert(GTK_TEXT(testtext),NULL,NULL,NULL,g_strconcat(\
 "?: ",ictdata.entry,"\n",NULL),i+4);break;
	case 2:/* error entry */
		i=fgetc(f);ictdata.entry[0]=0;fgets(ictdata.entry,i+1,f);
		gtk_text_insert(GTK_TEXT(testtext),NULL,NULL,NULL,g_strconcat(\
 "E: ",ictdata.entry,"\n",NULL),i+4);break;
	case 1:/* read entry */
		ictdata.entry[0]=fgetc(f);ictdata.entry[1]=fgetc(f);
		ictdata.entry[2]=fgetc(f);ictdata.entry[3]=fgetc(f);
		dofrom4(ictdata.entry);/* get string */
		gtk_text_insert(GTK_TEXT(testtext),NULL,NULL,NULL,g_strconcat(\
 "R: ",ictdata.entry,"\n",NULL),20);break;
	case 0:/* write entry */
		ictdata.entry[0]=fgetc(f);ictdata.entry[1]=fgetc(f);
		ictdata.entry[2]=fgetc(f);ictdata.entry[3]=fgetc(f);
		dofrom4(ictdata.entry);/* get string */
		gtk_text_insert(GTK_TEXT(testtext),NULL,NULL,NULL,g_strconcat(\
 "W: ",ictdata.entry,"\n",NULL),20);break;
	default:/* kme? what's that? */
		sprintf(ictdata.entry,"%d",i);/* make string */
     		quick_message(g_strconcat("\nKme ?!\nUnknown action entry:\n\"",
	ictdata.entry,"\"\nThis information isn't added to test list.\n",
	"It's possible that this is part of new version, upgrade program.",
			NULL));
		i=13;while(!feof(f)&&(i>12)) i=fgetc(f);/* try to find end */
		break;/* wrote error */
   }/* end switch */
  }while(!feof(f));/* go to the end of file */
  gtk_text_thaw(GTK_TEXT (testtext));/* end test data update */
  fclose(f);/* close temp file */
 }/* end else if fopen */
 return(FALSE);/* close file and return ok */
}/* end else if fopen */
}/* end LoadEntry() */

gboolean isinfofile(gchar *fpath)
{/* if info file, returns TRUE and remove .info suffix */
gchar tmp[8];
gint i,j;

i=strlen(fpath)-5;/* get size of path */
for(j=0;j<5;j++) tmp[j]=fpath[i+j];tmp[5]=0;/* copy suffix */
if(strcmp(tmp,".info")==0){/* it's  info file */
 fpath[i]=0;return(TRUE);/* make entry */
}else return(FALSE);/* not a link file */
}/* end isinfofile() */ 

void LoadFromDir(const gchar *dlocation)
{
struct dirent *d;
struct stat s;
gint i,j,r;
DIR *D;
FILE *f;
gulong fotsize;
GtkWidget *progr;

if((D=opendir(dlocation))!=NULL){/* directory opened */
 r=0;while((d=readdir(D))!=NULL) r++;rewinddir(D);/* get size */
 d=readdir(D);i=1;/* read first entry (possible ".") */
 progr=create_progress(fileloc);gtk_widget_show(progr);/* make window */
 /* clean entries */
 adbi.tfnlist=NULL;adbi.lfnlist=NULL;adbi.changed=TRUE;/* allow saving */
 fileloc[0]=0;rezultat=-1;dialog_active=FALSE;ictdata.islnk=TRUE;
 ictdata.changed=FALSE;ictdata.entry[0]=0;
 gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (tfncombo)->entry),"");
 ictdata.tfname=FALSE;/* ok there isn't a new entry */
 gtk_entry_set_text(GTK_ENTRY (description), "");
 gtk_entry_set_text(GTK_ENTRY (truename), "");
 if(gtk_text_get_length(GTK_TEXT (testediclist))>0){/* clear tested ic list */
  gtk_text_set_point(GTK_TEXT (testediclist),0);
  gtk_text_forward_delete(GTK_TEXT (testediclist), gtk_text_get_length(GTK_TEXT (testediclist)));}/* end if length */
 if(gtk_text_get_length(GTK_TEXT (authorslist))>0){/* clear author list */
  gtk_text_set_point(GTK_TEXT (authorslist),0);
  gtk_text_forward_delete(GTK_TEXT (authorslist), gtk_text_get_length(GTK_TEXT (authorslist)));}/* end if length */
 gtk_entry_set_text(GTK_ENTRY (moddate), "");
 gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (lfncombo)->entry), "");
 if(gtk_text_get_length(GTK_TEXT(testtext))>0){/* clear data */
  gtk_text_set_point(GTK_TEXT (testtext),0);
  gtk_text_forward_delete(GTK_TEXT(testtext),gtk_text_get_length(GTK_TEXT(testtext)));}/* end if length */
 while(d!=NULL){/* go thru listing */
  gtk_progress_bar_update(GTK_PROGRESS_BAR(pprogressbar),(gfloat)i/(gfloat)r);
  sprintf(fileloc,"%s/%s",dlocation,d->d_name);/* make full path */
  stat(fileloc, &s);/* get status of entry */
  if(S_ISREG(s.st_mode)){/* it's file */
   if(isinfofile(fileloc)){/* ok it's info file read it */
    if((f=fopen(g_strconcat(fileloc,".info",NULL),"rb"))==NULL){/* open fail */
     qdialog(g_strconcat("\nWoha!!!\nCan not open info file!\n",
	"Error:",g_strerror(errno),"\nCancel database loading?\n",NULL));
     if(rezultat==1){ init_all();break; }/* Ok abort */
    }else{/* all ok, read file */
     j=fgetc(f);ictdata.entry[0]=0;fgets(ictdata.entry,(j&127)+1,f);/* read */
     gtk_label_set_text(GTK_LABEL(plabel),ictdata.entry);g_refresh();
     adbi.tfnlist=g_list_insert_sorted(adbi.tfnlist, g_strdup(ictdata.entry),
	(GCompareFunc) strcmp);/* insert sorted into list */
     if (j&128) {/* link entry read location */
      j=fgetc(f);ictdata.entry[0]=0;fgets(ictdata.entry,j+1,f);/* read entry */
      if(g_list_find_custom(adbi.lfnlist,ictdata.entry,(GCompareFunc) strcmp)==
	NULL) /* ok, there's no entry, add new */
       adbi.lfnlist=g_list_insert_sorted(adbi.lfnlist, g_strdup(ictdata.entry),
	(GCompareFunc) strcmp);/* add to link list */
     }else if(g_list_find_custom(adbi.lfnlist,ictdata.entry,
	(GCompareFunc) strcmp)==NULL) /* ok, there's no entry, add new */
	adbi.lfnlist=g_list_insert_sorted(adbi.lfnlist,g_strdup(ictdata.entry),
	(GCompareFunc) strcmp);/* add to link list */
     fotsize=(gulong)fgetc(f)*256*256*256;fotsize+=(gulong)fgetc(f)*256*256;
     fotsize+=(gulong)fgetc(f)*256;fotsize+=(gulong)fgetc(f);/* temp size */
     fclose(f);/* close info file */
     if((f=fopen(g_strconcat(fileloc,".tmp",NULL),"rb"))==NULL){/* open fail */
      qdialog(g_strconcat("\nWoha!!!\nCan not open temp file!\n",
	"Error:",g_strerror(errno),"\nCancel database loading?\n",NULL));
      if(rezultat==1){ init_all();break; }/* Ok abort */
     }else{/* all ok get size */
      fseek(f,0L,SEEK_END);if(ftell(f)!=fotsize){/* size not match */
	      g_print("temp size %ld (%ld)\n",fotsize,ftell(f));
       qdialog(g_strconcat("\nZzzuj!?!\nError: Temp file construction don't\
 match to one wroted in info file.\nCancel database loading?\n",NULL));
       if(rezultat==1){ fclose(f);init_all();break; }/* Ok abort */
      }/* end if size not match */
       fclose(f);/* close temp file */
     }/* end else if fopen temp */
    }/* end else if fopen info */
   }/* end if is info file */
  }else{/* end if it's file */
   gtk_label_set_text(GTK_LABEL(plabel),"");g_refresh();}/* do refresh */
  d=readdir(D);i++;/* read next entry */
 }/* end while */
 closedir(D);gtk_widget_destroy(progr);/* close directory */
 if(adbi.tfnlist==NULL){/* empty list */
  adbi.tfnlist=g_list_append(adbi.tfnlist,"");gtk_combo_set_popdown_strings(\
	GTK_COMBO(tfncombo),adbi.tfnlist);adbi.tfnlist=NULL;
 }else/* there's elements in list, do only update */
  gtk_combo_set_popdown_strings(GTK_COMBO(tfncombo),adbi.tfnlist);/* update */
  gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (tfncombo)->entry),"");
 if(adbi.lfnlist==NULL){/* empty list */
  adbi.lfnlist=g_list_append(adbi.lfnlist,"");gtk_combo_set_popdown_strings(\
	GTK_COMBO(lfncombo),adbi.lfnlist);adbi.lfnlist=NULL;
 }else/* there's elements in list, do only update */
  gtk_combo_set_popdown_strings(GTK_COMBO(lfncombo),adbi.lfnlist);/* update */
  gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (lfncombo)->entry),"");
}else{/* directory not opened */
 quick_message(g_strconcat("\nMmrlj, can not open database directory for read \
!\nError: ",g_strerror(errno),NULL));init_all();}/* reset all */
}/* end LoadFromDir() */

gboolean LoadFromDatabase(const gchar *flocation)
{
FILE *df,*ff;
gulong dfsize,fotsize;
gint i;
GtkWidget *progr;

if((df=fopen(g_strconcat(flocation,"t",NULL),"rb"))==NULL){/* fail to read */
 quick_message(g_strconcat("\nMmrlj, can not open database for read !\n\
 Error: ",g_strerror(errno),NULL));return(TRUE);/* return error */
}else{/* all ok read database */
 fseek(df,0L,SEEK_END);dfsize=ftell(df);rewind(df);/* get size of database */
 if((fgetc(df)==255)&&(fgetc(df)==0)){/* it's ic-tester database */ 
  sprintf(fileloc,"Loading database type %d...",fgetc(df));/* make title */
  progr=create_progress(fileloc);gtk_widget_show(progr);/* make window */
  gtk_label_set_text(GTK_LABEL(plabel),"");gtk_progress_bar_update(\
	GTK_PROGRESS_BAR(pprogressbar),(gfloat)ftell(df)/(gfloat)dfsize);
  g_refresh();/* update progress and do refresh */
  /* clean entries */
  adbi.changed=FALSE;adbi.tfnlist=NULL;adbi.lfnlist=NULL;
  fileloc[0]=0;rezultat=-1;dialog_active=FALSE;ictdata.islnk=TRUE;
  ictdata.changed=FALSE;ictdata.entry[0]=0;
  gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (tfncombo)->entry),"");
  ictdata.tfname=FALSE;/* ok there isn't a new entry */
  gtk_entry_set_text(GTK_ENTRY (description), "");
  gtk_entry_set_text(GTK_ENTRY (truename), "");
  if(gtk_text_get_length(GTK_TEXT (testediclist))>0){/* clear tested ic list */
   gtk_text_set_point(GTK_TEXT (testediclist),0);
   gtk_text_forward_delete(GTK_TEXT (testediclist), gtk_text_get_length(GTK_TEXT (testediclist)));}/* end if length */
  if(gtk_text_get_length(GTK_TEXT (authorslist))>0){/* clear author list */
   gtk_text_set_point(GTK_TEXT (authorslist),0);
   gtk_text_forward_delete(GTK_TEXT (authorslist), gtk_text_get_length(GTK_TEXT (authorslist)));}/* end if length */
  gtk_entry_set_text(GTK_ENTRY (moddate), "");
  gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (lfncombo)->entry), "");
  if(gtk_text_get_length(GTK_TEXT(testtext))>0){/* clear data */
   gtk_text_set_point(GTK_TEXT (testtext),0);
   gtk_text_forward_delete(GTK_TEXT(testtext),gtk_text_get_length(GTK_TEXT(testtext)));}/* end if length */
  i=fgetc(df);/* get size of string */
  while(!feof(df)){/* until you get to the end of file */
   fgets(ictdata.entry,(i&127)+1,df);/* get string */
   gtk_label_set_text(GTK_LABEL(plabel),ictdata.entry);/* set name */
   gtk_progress_bar_update(GTK_PROGRESS_BAR(pprogressbar),
	(gfloat)ftell(df)/(gfloat)dfsize);g_refresh();/* update progress */
   sprintf(fileloc,"%s/%s",flocation,ictdata.entry);/* info file path */
   if((ff=fopen(g_strconcat(fileloc,".info",NULL),"wb"))==NULL)
   {/* cann't write to info file */
    qdialog(g_strconcat("\nWoha!!!\nCan not open info file!\n",
	"Error:",g_strerror(errno),"\nCancel database loading?\n",NULL));
    if(rezultat==1){/* Ok abort */
     fclose(df);return(TRUE);/* return error */
    }else{/* skip this entry and continue to load */
     ff=NULL;if(i&128) fseek(df,(glong)fgetc(df),SEEK_CUR);/* skip data */
    fotsize=(gulong)fgetc(df)*256*256*256;fotsize+=(gulong)fgetc(df)*256*256;
    fotsize+=(gulong)fgetc(df)*256;fotsize+=(gulong)fgetc(df);/* temp size */
    fseek(df,(glong)fotsize,SEEK_CUR);/* skip data */
    }/* end else if abort */
   }else{/* all ok write data */
    adbi.tfnlist=g_list_insert_sorted(adbi.tfnlist, g_strdup(ictdata.entry),
	(GCompareFunc) strcmp);/* insert sorted into list */
    fprintf(ff,"%c%s",i,ictdata.entry);/* write first entry */
    if (i&128) {/* link entry read location */
     i=fgetc(df);ictdata.entry[0]=0;fgets(ictdata.entry,i+1,df);/* read entry */
     fprintf(ff,"%c%s",i,ictdata.entry);/* write link entry */
     if(g_list_find_custom(adbi.lfnlist,ictdata.entry,(GCompareFunc) strcmp)==
	NULL) /* ok, there's no entry, add new */
     adbi.lfnlist=g_list_insert_sorted(adbi.lfnlist, g_strdup(ictdata.entry),
	(GCompareFunc) strcmp);/* add to link list */
    }else if(g_list_find_custom(adbi.lfnlist,ictdata.entry,
	(GCompareFunc) strcmp)==NULL) /* ok, there's no entry, add new */
	adbi.lfnlist=g_list_insert_sorted(adbi.lfnlist,g_strdup(ictdata.entry),
	(GCompareFunc) strcmp);/* to link list */
    i=fgetc(df);fputc(i,ff);fotsize=(gulong)i*256*256*256;i=fgetc(df);
    fputc(i,ff);fotsize+=(gulong)i*256*256;i=fgetc(df);fputc(i,ff);
    fotsize+=(gulong)i*256;i=fgetc(df);fputc(i,ff);fotsize+=(gulong)i;
    fclose(ff);/* close info file */
   }/* end else if fopen info */
   gtk_progress_bar_update(GTK_PROGRESS_BAR(pprogressbar),
	(gfloat)ftell(df)/(gfloat)dfsize);g_refresh();/* update progress */
   if((ff=fopen(g_strconcat(fileloc,".tmp",NULL),"wb"))==NULL)
   {/* cann't write to temp file */
    qdialog(g_strconcat("\nWoha!!!\nCan not open temp file!\n",
	"Error:",g_strerror(errno),"\nCancel database loading?\n",NULL));
    if(rezultat==1){/* Ok abort */
     fclose(df);return(TRUE);/* return error */
    }else{/* skip this entry and continue to load */
     remove(g_strconcat(fileloc,".info",NULL));ff=NULL;/* remove this entry */
     fseek(df,(glong)fotsize,SEEK_CUR);fotsize=0;/* skip data */
    }/* end else if abort */
   }else{/* all ok write data */
    while((glong)fotsize>0){/* copy data until end */ 
     if(fotsize>=255) i=fread(ictdata.entry,1,255,df);/* normal reading */
     else i=fread(ictdata.entry,1,(gint)fotsize,df);/* reduced reading */
     if(i!=fwrite(ictdata.entry,1,i,ff)) {/* write error */
      qdialog(g_strconcat("\nWoha!!!\nCan not write to temp file!\n",
	"Error:",g_strerror(errno),"\nCancel database loading?\n",NULL));
      if(rezultat==1){/* Ok abort */
       fclose(ff);fclose(df);return(TRUE);/* return error */
      }else{/* skip this entry and continue to load */
       fclose(ff);remove(g_strconcat(fileloc,".tmp",NULL));remove(g_strconcat(\
	fileloc,".info",NULL));ff=NULL;/* remove this entry */
       fseek(df,(glong)fotsize,SEEK_CUR);fotsize=0;i=0;/* skip data */
      }/* end else if abort */
     }/* end if write error */
     fotsize-=(gulong)i;/* reduce total size */
    }/* end while to the end of temp file */
    if(ff!=NULL) fclose(ff);/* close temp file */
   }/* end else if fopen temp */
   i=fgetc(df);/* get size of string */
  }/* end while go thru file */
 }else{/* not a ic-tester database */
  fclose(df);quick_message(g_strconcat("\nCann't load database \"",flocation,
	"\" !!!\nError: Not a IC-tester database.\n",NULL));return(TRUE);
 }/* end else if ic-tester database */
 if(adbi.tfnlist==NULL){/* empty list */
  adbi.tfnlist=g_list_append(adbi.tfnlist,"");gtk_combo_set_popdown_strings(\
	GTK_COMBO(tfncombo),adbi.tfnlist);adbi.tfnlist=NULL;
 }else/* there's elements in list, do only update */
  gtk_combo_set_popdown_strings(GTK_COMBO(tfncombo),adbi.tfnlist);/* update */
  gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (tfncombo)->entry),"");
 if(adbi.lfnlist==NULL){/* empty list */
  adbi.lfnlist=g_list_append(adbi.lfnlist,"");gtk_combo_set_popdown_strings(\
	GTK_COMBO(lfncombo),adbi.lfnlist);adbi.lfnlist=NULL;
 }else/* there's elements in list, do only update */
  gtk_combo_set_popdown_strings(GTK_COMBO(lfncombo),adbi.lfnlist);/* update */
  gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (lfncombo)->entry),"");
 fclose(df);gtk_widget_destroy(progr);return(FALSE);/* return ok */
}/* end else if database open */
}/* end LoadFromDatabase() */
