/******************************************************************************
    Program ictdatedit, builds and edit database from analyze test files,
    for ic-tester program:
    - refresh.c - source file for update functions

    Copyright (C) 2001 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/

#include "ictdat.h"

void g_refresh(void)/* update window and check for inputs */
{
while (gtk_events_pending())/* check if something pressed on window */
 gtk_main_iteration();/* update events */
}/* end g_refresh() */

void update_entries(void)
{
gboolean tmp;/* for preserving value */

if(adbi.databaseloc[0]==0){/* there's no database, diasble all */
 gtk_label_set_text (GTK_LABEL (databaseloc), "No database selected");
 gtk_label_set_text (GTK_LABEL (GTK_BUTTON(savedatabase)->child), "New");
 gtk_widget_set_sensitive(typeIsize, FALSE);
 gtk_widget_set_sensitive(islink, FALSE);
 gtk_widget_set_sensitive(istest, FALSE);
 gtk_editable_set_editable(GTK_EDITABLE(GTK_COMBO (tfncombo)->entry), FALSE);
 if(adbi.tfnlist!=NULL)/* set only if there's data */
  gtk_combo_set_popdown_strings (GTK_COMBO (tfncombo), adbi.tfnlist);
 gtk_widget_set_sensitive(tfncombo, FALSE);
 gtk_widget_set_sensitive(savebutton, FALSE);
 gtk_widget_set_sensitive(newbutton, FALSE);
 gtk_widget_set_sensitive(delbutton, FALSE);
 gtk_widget_set_sensitive(inportbutton, FALSE);
 gtk_widget_set_sensitive(description, FALSE);
 gtk_widget_set_sensitive(truename, FALSE);
 gtk_widget_set_sensitive(testediclist, FALSE);
 gtk_widget_set_sensitive(authorslist, FALSE);
 gtk_widget_set_sensitive(moddate, FALSE);/* time */
 gtk_widget_set_sensitive(lfncombo, FALSE);
 if(adbi.lfnlist!=NULL)/* set only if there's data */
  gtk_combo_set_popdown_strings (GTK_COMBO (lfncombo), adbi.lfnlist);
 gtk_widget_set_sensitive(exportbutton, FALSE);
 gtk_widget_set_sensitive(testtext, FALSE);
}else{/* ok there's database, enable some buttons */
 gtk_label_set_text (GTK_LABEL (databaseloc), adbi.databaseloc);
 if(adbi.changed)/* there's changes in database */
  gtk_label_set_text (GTK_LABEL (GTK_BUTTON(savedatabase)->child), "Save");
 else/* no changes in database */
  gtk_label_set_text (GTK_LABEL (GTK_BUTTON(savedatabase)->child), "New");
 gtk_widget_set_sensitive(typeIsize, TRUE);
 gtk_widget_set_sensitive(tfncombo, TRUE);
 gtk_widget_set_sensitive(newbutton, TRUE);
 gtk_widget_set_sensitive(inportbutton, TRUE);
 if(!ictdata.tfname){/* there's no entry */
  gtk_widget_set_sensitive(islink, FALSE);
  gtk_widget_set_sensitive(istest, FALSE);
  gtk_editable_set_editable(GTK_EDITABLE(GTK_COMBO (tfncombo)->entry), FALSE);
  gtk_widget_set_sensitive(savebutton, FALSE);
  gtk_widget_set_sensitive(delbutton, FALSE);
  gtk_widget_set_sensitive(description, FALSE);
  gtk_widget_set_sensitive(truename, FALSE);
  gtk_widget_set_sensitive(testediclist, FALSE);
  gtk_widget_set_sensitive(authorslist, FALSE);
  gtk_widget_set_sensitive(moddate, FALSE);/* time */
  gtk_widget_set_sensitive(lfncombo, FALSE);
  gtk_widget_set_sensitive(exportbutton, FALSE);
  gtk_widget_set_sensitive(testtext, FALSE);
 }else{/* there's selected entry */
  gtk_widget_set_sensitive(islink, TRUE);
  gtk_widget_set_sensitive(istest, TRUE);
  tmp=ictdata.changed;/* remember state */
  if(ictdata.islnk){/* it's link */
   gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (islink), TRUE);
   gtk_widget_set_sensitive(lfncombo, TRUE);
   gtk_widget_set_sensitive(testtext, FALSE);
  }else{/* there's data */
   gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (istest), TRUE);
   gtk_widget_set_sensitive(lfncombo, FALSE);
   gtk_widget_set_sensitive(testtext, TRUE);
  }/* end else if islink */
  ictdata.changed=tmp;/* restore state */
  gtk_editable_set_editable(GTK_EDITABLE(GTK_COMBO (tfncombo)->entry), TRUE);
  if(ictdata.changed){/* there's changes */
   gtk_widget_set_sensitive(savebutton, TRUE);
   gtk_widget_set_sensitive(delbutton, FALSE);
  }else{/* no changes */
   gtk_widget_set_sensitive(savebutton, FALSE);
   gtk_widget_set_sensitive(delbutton, TRUE);
  }/* end else no changes */
  gtk_widget_set_sensitive(description, TRUE);
  gtk_widget_set_sensitive(truename, TRUE);
  gtk_widget_set_sensitive(testediclist, TRUE);
  gtk_widget_set_sensitive(authorslist, TRUE);
  gtk_widget_set_sensitive(moddate, TRUE);/* time */
  gtk_widget_set_sensitive(exportbutton, TRUE);
 }/* end else if there's entry */
}/* end else if there's database */
}/* end update_entries() */
