/******************************************************************************
    Program ictdatedit, builds and edit database from analyze test files,
    for ic-tester program:
    - testfile.c - source file for working with test (analyze) files

    Copyright (C) 2001 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>

#include "ictdat.h"
#include "timeset.h"
#include "dialog.h"
#include "refresh.h"

void gfn(char *where,const char *fpath)
{/* get file name prom path */
gchar ch[256];
gint i,j,k;

i=strlen(fpath)-1;/* get size of path */
while (fpath[i]!='/') i--;i++;j=i;/* get begining of name */
while((fpath[j]!='.')&&(fpath[j]!=0)) j++;j--;/* get end of name */
for (k=0;i<=j;i++) { ch[k]=fpath[i];k++; } ch[k]=0;/* make string */
strcpy(where,ch);
}/* end gfn() */

void aextrcat(gchar *what)
{
gint i;
gchar str[256];

for(i=3;i<strlen(what);i++) str[i-3]=what[i];str[i-3]=0;
strcpy(what,str);/* update wariable */
}/* end aextrcat() */

gboolean addtestfile(const char *file)
{
FILE *f;
gchar s[256];
gboolean ret,eofc;/* return and End Of First Comment */

if((f=fopen(file,"r"))==NULL){/* cann't read file */
 quick_message(g_strconcat("\nOho, can not open file ",file,"!\nError: ",
		g_strerror(errno),NULL));ret=FALSE;
}else{/* all ok file open */
 ret=TRUE;eofc=FALSE;fgets(s,256,f);/* read 1st line to determine file type */
 if(strcmp(s,"Analyze IC Tester link\n")==0){/* it's link file */
  fgets(s,256,f);/* read information line and skip it */
  s[0]=0;fgets(s,256,f);s[strlen(s)-1]=0;/* get link location */
  gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (lfncombo)->entry), s);
  ictdata.tfname=TRUE;gfn(s,file);ictdata.islnk=TRUE;/* make link entry */
  gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (tfncombo)->entry), s);
  s[0]=0;fgets(s,256,f);/* get next entry */
  gtk_entry_set_text(GTK_ENTRY (description), "");
  gtk_entry_set_text(GTK_ENTRY (truename), "");
  if(gtk_text_get_length(GTK_TEXT (testediclist))>0){/* clear tested ic list */
   gtk_text_set_point(GTK_TEXT (testediclist),0);
   gtk_text_forward_delete(GTK_TEXT (testediclist), gtk_text_get_length(GTK_TEXT (testediclist)));}/* end if length */
  if(gtk_text_get_length(GTK_TEXT (authorslist))>0){/* clear author list */
   gtk_text_set_point(GTK_TEXT (authorslist),0);
   gtk_text_forward_delete(GTK_TEXT (authorslist), gtk_text_get_length(GTK_TEXT (authorslist)));}/* end if length */
  if(gtk_text_get_length(GTK_TEXT (testtext))>0){/* clear test data */
   gtk_text_set_point(GTK_TEXT (testtext),0);
   gtk_text_forward_delete(GTK_TEXT(testtext),gtk_text_get_length(
	GTK_TEXT(testtext)));}/* end if length */
  if((s[0]!=0)&&(s[0]!=' ')&&(s[0]!='\n')){/* ok new link */
	  /* &&(s[0]!='#') - not need any more, controled from test file */
   gtk_text_freeze(GTK_TEXT(testtext));/* hold writing data */
   do{/* go thru file */
    s[0]=0;fgets(s,256,f);/* read line by line */
    if( (s[0]!=0)&&(s[0]!=32)&&(s[0]!='\n') ){/* &&(s[0]!='#') - erase it? */
     if(s[1]==':'){/* data entry process it */
     switch (s[0]){/* find type of information */
      case 'A':/* author entry */
	     aextrcat(s);/* clean info letter */
	     gtk_text_insert(GTK_TEXT(authorslist),NULL,NULL,NULL,s,strlen(s));
	     break;/* extract data */
      case 'M':/* date entry */
	     aextrcat(s);tbextrcpy(s);break;/* extract time data */
      case 'D':/* description entry */
	     aextrcat(s);/* clean info letter */
	     gtk_entry_set_text(GTK_ENTRY (description), s);break;
      case 'I':/* not tested entry */
	     aextrcat(s);/* clean info letter */
	     quick_message(g_strconcat("\nObsolete entry:\n",s,"\nList of ics\
 which this test file may work is obsolete.\nUse link to point at this file\
 for that.\n",NULL));break;/* obsolete, use links for that */
      case 'T':/* tested entry */
	     aextrcat(s);/* clean info letter */
	     gtk_text_insert(GTK_TEXT(testediclist),NULL,NULL,NULL,s,strlen(s));
	     break;/* extract data */
      case 'N':/* true ic name entry */
	     aextrcat(s);/* clean info letter */
  	     gtk_entry_set_text(GTK_ENTRY (truename), s);break;/* add truname */
      case 'P':/* paused entry */
      case 'W':/* write entry */
      case 'R':/* read entry */
      case 'E':/* error entry */
      case '?':/* error input entry */
	     gtk_text_insert(GTK_TEXT(testtext),NULL,NULL,NULL,s,strlen(s));
	     break;/* add test data */
      default:/* unknown entry */
	     qdialog(g_strconcat("\nError: Unknown entry:\n\"",s,"\"\nIt's\
 possible that this may be part of new version or it could be some garbage.\n\
Do you wish to discard this entry?\n",NULL));
	     if(rezultat==0)
	      gtk_text_insert(GTK_TEXT(testtext),NULL,NULL,NULL,s,strlen(s));
	     break;/* add test data */
     }/* end switch */
     }else if(s[0]=='#'){/* it's comment, check if we can add it */
      if(eofc) gtk_text_insert(GTK_TEXT(testtext),NULL,NULL,NULL,s,strlen(s));
      else if(strcmp(s,"######### Test part from here if any #############\n")==0) eofc=TRUE;/* found end of first auto inserted comments */
     }/* end if it's comment */
    }/* end if is data line */
   }while(!feof(f));/* end go thru file */
   gtk_text_thaw(GTK_TEXT(testtext));/* repaste all */
  }else SetNewTime();/* get new time if not new link entry */
 }else if(strcmp(s,"Analyze IC Tester data\n")==0){/* it's test file */
  ictdata.islnk=FALSE;gfn(s,file);ictdata.tfname=TRUE;
  gtk_entry_set_text(GTK_ENTRY (description), "");
  gtk_entry_set_text(GTK_ENTRY (truename), "");
  gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (tfncombo)->entry), s);
  gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (lfncombo)->entry), "");
  if(gtk_text_get_length(GTK_TEXT (testediclist))>0){/* clear tested ic list */
   gtk_text_set_point(GTK_TEXT (testediclist),0);
   gtk_text_forward_delete(GTK_TEXT (testediclist), gtk_text_get_length(GTK_TEXT (testediclist)));}/* end if length */
  if(gtk_text_get_length(GTK_TEXT (authorslist))>0){/* clear author list */
   gtk_text_set_point(GTK_TEXT (authorslist),0);
   gtk_text_forward_delete(GTK_TEXT (authorslist), gtk_text_get_length(GTK_TEXT (authorslist)));}/* end if length */
  if(gtk_text_get_length(GTK_TEXT (testtext))>0){/* clear test data */
   gtk_text_set_point(GTK_TEXT (testtext),0);
   gtk_text_forward_delete(GTK_TEXT(testtext),gtk_text_get_length(
	GTK_TEXT(testtext)));}/* end if length */
  gtk_text_freeze(GTK_TEXT(testtext));/* hold writing data */
  do{/* go thru file */
   s[0]=0;fgets(s,256,f);/* read line by line */
   if( (s[0]!=0)&&(s[0]!=32)&&(s[0]!='\n') ){/* &&(s[0]!='#') - erase it? */
    if(s[1]==':'){/* data entry process it */
    switch (s[0]){/* find type of information */
     case 'A':/* author entry */
	     aextrcat(s);/* clean info letter */
	     gtk_text_insert(GTK_TEXT(authorslist),NULL,NULL,NULL,s,strlen(s));
	     break;/* extract data */
     case 'M':/* date entry */
	     aextrcat(s);tbextrcpy(s);break;/* extract time data */
     case 'D':/* description entry */
	     aextrcat(s);/* clean info letter */
	     gtk_entry_set_text(GTK_ENTRY (description), s);break;
     case 'I':/* not tested entry */
	     aextrcat(s);/* clean info letter */
	     quick_message(g_strconcat("\nObsolete entry:\n",s,"\nList of ics\
 which this test file may work is obsolete.\nUse link to point at this file\
 for that.\n",NULL));break;/* obsolete, use links for that */
     case 'T':/* tested entry */
	     aextrcat(s);/* clean info letter */
	     gtk_text_insert(GTK_TEXT(testediclist),NULL,NULL,NULL,s,strlen(s));
	     break;/* extract data */
     case 'N':/* true ic name entry */
	     aextrcat(s);/* clean info letter */
  	     gtk_entry_set_text(GTK_ENTRY (truename), s);
     case 'P':/* paused entry */
     case 'W':/* write entry */
     case 'R':/* read entry */
     case 'E':/* error entry */
     case '?':/* error input entry */
	     gtk_text_insert(GTK_TEXT(testtext),NULL,NULL,NULL,s,strlen(s));
	     break;/* add test data */
     default:/* unknown entry */
	     qdialog(g_strconcat("\nError: Unknown entry:\n\"",s,"\"\nIt's\
 possible that this may be part of new version or it could be some garbage.\n\
Do you wish to discard this entry?\n",NULL));
	     if(rezultat==0)
	      gtk_text_insert(GTK_TEXT(testtext),NULL,NULL,NULL,s,strlen(s));
	     break;/* add test data */
    }/* end switch */
    }else if(s[0]=='#'){/* it's comment, check if we can add it */
     if(eofc) gtk_text_insert(GTK_TEXT(testtext),NULL,NULL,NULL,s,strlen(s));
     else if(strcmp(s,"######### Test part from here #############\n")==0) eofc=TRUE;/* found end of first auto inserted comments */
    }/* end if it's comment */
   }/* end if is data line */
  }while(!feof(f));/* end go thru file */
  gtk_text_thaw(GTK_TEXT(testtext));/* repaste all */
 }else{/* unknown file type */
  quick_message(g_strconcat("\nCann't read file ",file,"!\nError: Unknown file\
 type.",NULL));ret=FALSE;}
 fclose(f);/* close file */
}/* end else if fopen */
fileloc[0]=0;return(ret);/* reset file location */
}/* end addtestfile() */

void exptestfile(const char *file)
{
FILE *f;
guint j;
gulong i;
gchar s[256];

if((f=fopen(file,"w"))==NULL)/* cann't write to file */
 quick_message(g_strconcat("\nOho, can not open file ",file,"!\nError: ",
		g_strerror(errno),NULL));
else{/* all ok file open */
 strcpy(ictdata.entry,gtk_entry_get_text(GTK_ENTRY(moddate)));/* get date */
 SetNewTime();/* get new time for writing */
 if(ictdata.islnk){/* it's link file */
  fprintf(f,"Analyze IC Tester link\n");/* write file type */
  fprintf(f,"Information: Testing %s is done with test file of %s, loading \
file...\n",gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(tfncombo)->entry)),
	gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(lfncombo)->entry)));
  fprintf(f,"%s\n",gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(lfncombo)->entry)));
  fprintf(f,"Generated from database editor v%s.\n",VERSION);
  fprintf(f,"# This is new link type, for edit use this structure:\n\
# First line: identification for program.\n# Second line: Information wich \
will be displayed to user.\n# Third line: location of test file.\n# Other \
lines are identical like in test file.\n\n# Write informations before any W:, \
R:, E: or ?: actions !!!!\n");
  j=0;for((guint)i=0;(guint)i<gtk_text_get_length(GTK_TEXT(authorslist));i++){
   s[j]=GTK_TEXT_INDEX(GTK_TEXT(authorslist),(guint)i);
   if((s[j]=='\n')||(j>=76)){/* end of line */
    if(s[j]=='\n') s[j]=0; else s[j+1]=0;j=0;/* make string */
    fprintf(f,"A: %s\n",s);/* write author entry */
   }else j++;/* not end of line */
  }/* end for i */
  fprintf(f,"# use formated date as YYYY/MM/DD-HH:MM-ZONE, eq: date +%%Y/%%m/\
%%d-%%H:%%M-%%Z\nM: %s\n",gtk_entry_get_text(GTK_ENTRY(moddate)));
  fprintf(f,"D: %s\n",gtk_entry_get_text(GTK_ENTRY(description)));
  j=0;for((guint)i=0;(guint)i<gtk_text_get_length(GTK_TEXT(testediclist));i++){
   s[j]=GTK_TEXT_INDEX(GTK_TEXT(testediclist),(guint)i);
   if((s[j]=='\n')||(j>=76)){/* end of line */
    if(s[j]=='\n') s[j]=0; else s[j+1]=0;j=0;/* make string */
    fprintf(f,"T: %s\n",s);/* write tested ic's entry */
   }else j++;/* not end of line */
  }/* end for i */
  fprintf(f,"N: %s\n\n# Delete next comment line if you don't want comments in databse.\n######### Test part from here if any #############\n",
	gtk_entry_get_text(GTK_ENTRY(truename)));
  for(i=0;i<gtk_text_get_length(GTK_TEXT(testtext));i++)/* write test data */
   fprintf(f,"%c",GTK_TEXT_INDEX(GTK_TEXT(testtext),i));
 }else{/* it's test file */
  fprintf(f,"Analyze IC Tester data\n");/* write file type */
  fprintf(f,"#################################################################\
###########\n# This is autogenerated temporary test file from database editor \
v%s.\n# It's used for further testing and upgrading, you can copy, modify it \
or\n# write your own test file.\n# Each data wich programs read begins with \
action letter and ':' character,\n# after which you write parametars for that \
action.\n# List of action letters:\n",VERSION);
  fprintf(f,"#\tA: (0/65025) - Entry for author name and (or) e-mail address.\n\
#\tM:    (1/20) - Last modify date.\n#\tD:   (1/255) - Description of tested \
IC.\n#\tT: (0/65025) - Title of ICs which this test works and it's tested.\n\
#\tN:   (1/255) - Real name of tested ic.\n#\tP:    (1/10) - Pause for number \
of miliseconds (1000 msec = 1 sec).\n#\tW:    (?/16) - Set power on test \
socket, input entry indentical like in\n# '-w' option ( 1:+5V, 0:GND, =:Not \
connected (NC)).\n");
  fprintf(f,"#\tR:    (?/16) - Read data from test socket, if readed data don\
't match\n# with one you write then test fails. Use this letters to get \
detailed output:\n# 1:there is +5V or is NC, 0:there is GND, =:ignore what \
you get.\n#\tE:   (?/255) - Error report, write what's wrong with tested IC.\n\
#\t?:   (?/255) - If there was error, write message, and ask for continue.\n\
#\t       `--(number of possible lines in test file/max size of line)\n");
  fprintf(f,"# If in numbers of possible lines is:\n#\t0, you can write \
unlimited lines, until total characters in lines reach\n# max size of line \
(number of charcters).\n#\t?, you can write unlimited lines, with up to max \
size.\n\n# Write informations before any W:, R:, E: or ?: actions !!!!\n");
  j=0;for((guint)i=0;(guint)i<gtk_text_get_length(GTK_TEXT(authorslist));i++){
   s[j]=GTK_TEXT_INDEX(GTK_TEXT(authorslist),(guint)i);
   if((s[j]=='\n')||(j>=76)){/* end of line */
    if(s[j]=='\n') s[j]=0; else s[j+1]=0;j=0;/* make string */
    fprintf(f,"A: %s\n",s);/* write author entry */
   }else j++;/* not end of line */
  }/* end for i */
  fprintf(f,"# use formated date as YYYY/MM/DD-HH:MM-ZONE, eq: date +%%Y/%%m/\
%%d-%%H:%%M-%%Z\nM: %s\n",gtk_entry_get_text(GTK_ENTRY(moddate)));
  fprintf(f,"D: %s\n",gtk_entry_get_text(GTK_ENTRY(description)));
  j=0;for((guint)i=0;(guint)i<gtk_text_get_length(GTK_TEXT(testediclist));i++){
   s[j]=GTK_TEXT_INDEX(GTK_TEXT(testediclist),(guint)i);
   if((s[j]=='\n')||(j>=76)){/* end of line */
    if(s[j]=='\n') s[j]=0; else s[j+1]=0;j=0;/* make string */
    fprintf(f,"T: %s\n",s);/* write tested ic's entry */
   }else j++;/* not end of line */
  }/* end for i */
  fprintf(f,"N: %s\n\n# Delete next comment line if you don't want comments in databse.\n######### Test part from here #############\n",
	gtk_entry_get_text(GTK_ENTRY(truename)));
  for(i=0;i<gtk_text_get_length(GTK_TEXT(testtext));i++)/* write test data */
   fprintf(f,"%c",GTK_TEXT_INDEX(GTK_TEXT(testtext),i));
 }/* end else if link file */
 gtk_entry_set_text(GTK_ENTRY (moddate),ictdata.entry);/* write old date */
 fclose(f);/* close file */
}/* end else if fopen */
fileloc[0]=0;/* reset file location */
}/* end exptestfile() */
